#pragma once

#include <vector>
#include <picosha2/picosha2.h>

namespace Hsm {

	void sha256(const void* in_buffer, uint64_t in_length, void* out_buffer, uint64_t out_length)
	{
		auto in_chars = static_cast<const char*>(in_buffer);
		auto input = std::vector<char>(in_chars, in_chars + in_length);
		auto output = std::vector<char>(out_length);
		picosha2::hash256(input, output);
		Genode::memcpy(out_buffer, output.data(), out_length);
	}

}
