#pragma once

#include <libc/component.h>

namespace Hsm {
	void print(const void* buffer, uint64_t length)
	{
		auto buf = static_cast<const uint8_t*>(buffer);

		for (uint64_t i = 0; i < length; i += 16) {
			Genode::String<256> line("");
			for (uint64_t j = i; j < Genode::min(i + 16, length); j += 4) {
				for (uint64_t k = j; k < Genode::min(j + 4, length); k++) {
					line = Genode::String<256>(line, Genode::Hex(buf[k], Genode::Hex::OMIT_PREFIX, Genode::Hex::PAD));
				}
				line = Genode::String<256>(line, " ");
			}
			Genode::log(line);
		}
	}
}

